function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var MyAlgo = _interopDefault(require('@randlabs/myalgo-connect'));
var WalletConnect = _interopDefault(require('@walletconnect/client'));
var QRCodeModal = _interopDefault(require('algorand-walletconnect-qrcode-modal'));
var utils = require('@json-rpc-tools/utils');
var algoMsgpackWithBigint = require('algo-msgpack-with-bigint');
var base32 = _interopDefault(require('hi-base32'));

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var styles = {"AlgoButton":"_1E3Mb","AlgoSendButton":"_uMOg7"};

var Pipeline = /*#__PURE__*/function () {
  function Pipeline() {}

  Pipeline.init = function init() {
    this.EnableDeveloperAPI = false;
    this.indexer = "http://localhost:8980";
    this.algod = "http://localhost:4001";
    this.token = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
    this.devGenHash = "sC3P7e2SdbqKJK0tbiCdK9tdSpbe6XeCGKdoNzmlj0E=";
    this.devGenId = "devnet-v1.0";
    this.index = 0;
    this.pipeConnector = "myAlgoWallet";
    this.main = true;
    this.address = "";
    this.txID = "";
    this.myBalance = 0;
    this.connector = new WalletConnect({
      bridge: "https://bridge.walletconnect.org",
      qrcodeModal: QRCodeModal
    });
    return new MyAlgo();
  };

  Pipeline.balance = function balance(address) {
    try {
      var _this2 = this;

      var indexerURL = 'https://';

      if (_this2.main == true) {
        indexerURL = indexerURL + 'algoexplorerapi.io/idx2/v2/accounts/';
      } else {
        indexerURL = indexerURL + "testnet.algoexplorerapi.io/idx2/v2/accounts/";
      }

      if (_this2.EnableDeveloperAPI === true) {
        indexerURL = _this2.indexer + "/v2/accounts/";
      }

      var url2 = indexerURL + address;
      return Promise.resolve(_catch(function () {
        return Promise.resolve(fetch(url2)).then(function (data) {
          return Promise.resolve(data.json()).then(function (data2) {
            var data3 = JSON.stringify(data2.account.amount / 1000000) + ' Algos';
            _this2.myBalance = data3;
            return data3;
          });
        });
      }, function (error) {
        console.log(error);
        return 0;
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.connect = function connect(wallet) {
    try {
      var _exit2 = false;

      var _this4 = this;

      var _temp4 = function _temp4(_result2) {
        if (_exit2) return _result2;
        var getAddress = new Promise(function (resolve, reject) {
          setTimeout(function () {
            resolve(_this4.connector.accounts[0]);
          }, 10000);
        });
        return Promise.resolve(getAddress);
      };

      var _temp5 = function () {
        if (_this4.pipeConnector === "myAlgoWallet") {
          return _catch(function () {
            return Promise.resolve(wallet.connect()).then(function (accounts) {
              var item1 = accounts[0];
              item1 = item1['address'];
              _this4.address = item1;
              _exit2 = true;
              return item1;
            });
          }, function (err) {
            console.error(err);
          });
        } else {
          _this4.connector.on("connect", function (error, payload) {
            if (error) {
              throw error;
            }

            _this4.address = payload.params[0].accounts[0];
          });

          _this4.connector.on("session_update", function (error, payload) {
            alert(error + payload);

            if (error) {
              throw error;
            }
          });

          var _temp6 = function () {
            if (!_this4.connector.connected) {
              return Promise.resolve(_this4.connector.createSession()).then(function () {});
            } else {
              return Promise.resolve(_this4.connector.killSession()).then(function () {
                return Promise.resolve(_this4.connector.createSession()).then(function () {});
              });
            }
          }();

          if (_temp6 && _temp6.then) return _temp6.then(function () {});
        }
      }();

      return Promise.resolve(_temp5 && _temp5.then ? _temp5.then(_temp4) : _temp4(_temp5));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.walletConnectSign = function walletConnectSign(mytxnb) {
    try {
      var _this6 = this;

      var prototxn = {
        "amt": mytxnb.amount,
        "fee": 1000,
        "fv": mytxnb.lastRound - 1000,
        "gen": mytxnb.genesisID,
        "gh": new Uint8Array(Buffer.from(mytxnb.genesisHash, 'base64')),
        "lv": mytxnb.lastRound,
        "note": mytxnb.note,
        "rcv": new Uint8Array(base32.decode.asBytes(mytxnb.to).slice(0, 32)),
        "snd": new Uint8Array(base32.decode.asBytes(_this6.address).slice(0, 32)),
        "type": "pay"
      };
      var prototxnASA = {};
      var prototxnb = algoMsgpackWithBigint.encode(prototxn);
      var txns = [];
      txns[0] = prototxnb;

      if (_this6.index !== 0) {
        prototxnASA = {
          "aamt": mytxnb.amount,
          "arcv": new Uint8Array(base32.decode.asBytes(mytxnb.to).slice(0, 32)),
          "fee": 1000,
          "fv": mytxnb.lastRound - 1000,
          "gen": mytxnb.genesisID,
          "gh": new Uint8Array(Buffer.from(mytxnb.genesisHash, 'base64')),
          "lv": mytxnb.lastRound,
          "note": mytxnb.note,
          "snd": new Uint8Array(base32.decode.asBytes(_this6.address).slice(0, 32)),
          "type": "axfer",
          "xaid": parseInt(mytxnb.assetIndex)
        };
        prototxnb = algoMsgpackWithBigint.encode(prototxnASA);
        txns[0] = prototxnb;
      }

      console.log(prototxnb);
      console.log(new TextDecoder().decode(prototxnb));
      console.log(JSON.stringify(algoMsgpackWithBigint.decode(prototxnb)));
      var txnsToSign = txns.map(function (txnb) {
        var encodedTxn = Buffer.from(txnb).toString("base64");
        return {
          txn: encodedTxn,
          message: 'Description of transaction being signed'
        };
      });
      var requestParams = [txnsToSign];
      var request = utils.formatJsonRpcRequest("algo_signTxn", requestParams);
      request.id = _this6.connector._handshakeId;
      console.log(request);
      return Promise.resolve(_catch(function () {
        return Promise.resolve(_this6.connector.sendCustomRequest(request)).then(function (result) {
          var signedPartialTxn = result[0];
          var rawSignedTxn = Buffer.from(signedPartialTxn, "base64");
          return new Uint8Array(rawSignedTxn);
        });
      }, function (error) {
        console.log(error);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.send = function send(address, amt, myNote, _sendingAddress, wallet, index) {
    if (index === void 0) {
      index = 0;
    }

    try {
      var _this8 = this;

      var paramServer = 'https://';
      var transServer = 'https://';

      if (_this8.main == true) {
        paramServer = paramServer + 'algoexplorerapi.io/v2/transactions/params/';
        transServer = transServer + 'algoexplorerapi.io/v2/transactions/';
      } else {
        paramServer = paramServer + "testnet.algoexplorerapi.io/v2/transactions/params/";
        transServer = transServer + "testnet.algoexplorerapi.io/v2/transactions/";
      }

      if (_this8.EnableDeveloperAPI === true) {
        paramServer = _this8.algod + "/v2/transactions/params/";
        transServer = _this8.algod + "/v2/transactions/";
      }

      var buf = new Array(myNote.length);
      var encodedNote = new Uint8Array(buf);

      for (var i = 0, strLen = myNote.length; i < strLen; i++) {
        encodedNote[i] = myNote.charCodeAt(i);
      }

      console.log('My encoded note: ' + encodedNote);
      return Promise.resolve(_catch(function () {
        function _temp10() {
          function _temp8() {
            console.log(signedTxn);
            var requestHeaders = {
              'Content-Type': 'application/x-binary'
            };

            if (_this8.EnableDeveloperAPI === true) {
              requestHeaders = {
                'X-Algo-API-Token': _this8.token
              };
            }

            return Promise.resolve(fetch(transServer, {
              method: 'POST',
              headers: requestHeaders,
              body: signedTxn
            }).then(function (response) {
              return response.json();
            }).then(function (data) {
              return data.txId;
            })["catch"](function (error) {
              console.error('Error:', error);
            })).then(function (transactionID) {
              _this8.txID = transactionID;
              return transactionID;
            });
          }

          var txn = {
            from: _this8.address,
            to: address,
            amount: parseInt(amt),
            note: encodedNote,
            genesisID: 'mainnet-v1.0',
            genesisHash: 'wGHE2Pwdvd7S12BL5FaOP20EGYesN73ktiC1qzkkit8=',
            type: 'pay',
            flatFee: true,
            fee: 1000,
            firstRound: params['last-round'],
            lastRound: params['last-round'] + 1000
          };

          if (index !== 0) {
            _this8.index = index;
            txn.type = 'axfer';
            txn.assetIndex = parseInt(index);
          }

          if (_this8.main == false) {
            txn.genesisID = 'testnet-v1.0';
            txn.genesisHash = 'SGO1GKSzyE7IEPItTxCByw9x8FmnrCDexi9/cOUJOiI=';
          }

          if (_this8.EnableDeveloperAPI === true) {
            txn.genesisID = _this8.devGenId;
            txn.genesisHash = _this8.devGenHash;
          }

          console.log(txn);
          var signedTxn = {};

          var _temp7 = function () {
            if (_this8.pipeConnector === "myAlgoWallet") {
              return Promise.resolve(wallet.signTransaction(txn)).then(function (_wallet$signTransacti) {
                signedTxn = _wallet$signTransacti;
                signedTxn = signedTxn.blob;
              });
            } else {
              return Promise.resolve(_this8.walletConnectSign(txn)).then(function (_this7$walletConnectS) {
                signedTxn = _this7$walletConnectS;
              });
            }
          }();

          return _temp7 && _temp7.then ? _temp7.then(_temp8) : _temp8(_temp7);
        }

        var params = {};

        var _temp9 = function () {
          if (_this8.EnableDeveloperAPI === false) {
            return Promise.resolve(fetch(paramServer)).then(function (_fetch) {
              return Promise.resolve(_fetch.json()).then(function (_await$fetch$json) {
                params = _await$fetch$json;
              });
            });
          } else {
            return Promise.resolve(fetch(paramServer, {
              method: "GET",
              headers: {
                'X-Algo-API-Token': _this8.token
              }
            })).then(function (_fetch2) {
              return Promise.resolve(_fetch2.json()).then(function (_await$fetch$json2) {
                params = _await$fetch$json2;
                console.log("Params: " + JSON.stringify(params));
              });
            });
          }
        }();

        return _temp9 && _temp9.then ? _temp9.then(_temp10) : _temp10(_temp9);
      }, function (err) {
        console.error(err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return Pipeline;
}();
var AlgoSendButton = function AlgoSendButton(props) {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("button", {
    className: styles.AlgoSendButton,
    onClick: function onClick() {
      Pipeline.send(props.recipient, parseInt(props.amount || 1), props.note || "", Pipeline.myAddress, props.wallet, props.index || 0).then(function (data) {
        if (typeof data !== 'undefined') {
          if (props.returnTo !== undefined) {
            var object = {};
            object[props.returnTo] = data;
            props.context.setState(object);
          }

          if (typeof props.onChange === "function") {
            props.onChange(data);
          }
        }
      });
    }
  }, "Send"));
};
var AlgoButton = function AlgoButton(props) {
  return /*#__PURE__*/React.createElement("button", {
    className: styles.AlgoButton,
    onClick: function onClick() {
      Pipeline.connect(props.wallet).then(function (accounts) {
        if (props.returnTo !== undefined) {
          var data = {};
          data[props.returnTo] = accounts;
          props.context.setState(data);
        }

        if (typeof props.onChange === "function") {
          props.onChange(accounts);
        }
      });
    }
  }, "Connect");
};

exports.AlgoButton = AlgoButton;
exports.AlgoSendButton = AlgoSendButton;
exports.Pipeline = Pipeline;
//# sourceMappingURL=index.js.map
